#include <cstdlib>
#include <filesystem>
#include <iostream>
#include<json/json.h>

using std::cerr,std::endl,std::cout;

#define AS_EQ(a,b){if((a)!=(b)){cerr<<"assert eq failed :"<<endl<<#a<<":"<<(a)<<endl<<#b<<":"<<(b)<<endl;exit(1);}}
#define AS_NE(a,b){if((a)!=(b)){cerr<<"assert not eq failed :"<<endl<<#a<<":"<<(a)<<endl<<#b<<":"<<(b)<<endl;exit(1);}}
#define LOG(a){cout<<"[LOG]"<<(a)<<endl;}
#define AS_EM(a,b,m){if((a)!=(b)){cerr<<"assert eq failed :"<<endl<<#a<<":"<<(a)<<endl<<#b<<":"<<(b)<<endl<<"message:"<<(m)<<endl;exit(1);}}

int main(int argc, char* argv[]) {
    LOG("Zengtudor OI test tools . loading files .. please add a json file in arg");
    LOG("arg[0]")
    LOG(argv[0])
    AS_EQ(argc,2)
    std::filesystem::path p(argv[1]);
    if (!p.is_absolute()) {
        LOG("The path is not absolute, changing it")
        p = std::filesystem::current_path()/p;
    }
    LOG("getting json files current dir")
    LOG(p.string())
    LOG("will use g++ compiler")
    LOG("checking g++ compiler version")
    int sys_ret = system("g++ --version");
    AS_EM(sys_ret,0,"get g++ --version failed")
}